var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key2 of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key2) && key2 !== except)
        __defProp(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc(from, key2)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  getProps: () => getProps
});
module.exports = __toCommonJS(src_exports);
var import_hypercontroller = require("@hyperstackjs/hypercontroller");
var import_hyperstack = require("hyperstack");
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hyperstack:init-jwt");
var key = "jwt";
var getProps = () => import_hyperstack.context.initializerProps(key);
var src_default = (createLoader) => async (context2) => {
  const loader = createLoader(context2);
  const config = context2.config();
  const jwtSecretOrPublicKey = config.controllers.jwtSecret;
  if (!jwtSecretOrPublicKey) {
    throw new Error("No JWT secret is set in configuration");
  }
  const { MustAuthWithJWT, MustAuthRouteWithJWT, signJWT, verifyJWT } = (0, import_hypercontroller.authWithJWT)({
    secret: jwtSecretOrPublicKey,
    loader,
    bearer: void 0,
    jwtOptions: {
      expiresIn: config.controllers.jwtExpiry || "14d",
      algorithm: config.controllers.jwtAlgorithm || "HS512"
    }
  });
  return {
    provideProps() {
      return {
        [key]: {
          MustAuthWithJWT,
          MustAuthRouteWithJWT,
          signJWT,
          verifyJWT,
          currentUser(req) {
            if (!req.user) {
              debug("no user in request");
              throw (0, import_hypercontroller.err)("no user");
            }
            return req.user;
          }
        }
      };
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getProps
});
